/* 
Unlimited Simulator is copyrighted (c) Bruno Barberi Gnecco, 1999, and
distributed under the GNU General Public License (GPL). The conditions can be
found in the file GPL, resident at the main directory of the distribution.
*/
#ifndef ULSERVER_H
#define ULSERVER_H

#define SERVER
#include "unlimited.h"

struct pref_ul {
	sInt	port;
	Bool	anytime;	/* accept new connections anytime? */
	Bool	ai;		/* are ai clients allowed? */
	Bool	clientclient;	/* should clients talk to each other? if not,
				   all communications are done using the server */
	Bool	kickout;	/* may clients kick out other clients? */
	fFloat	kickmajority;	/* if yes, what's the percentage of clients
				   voting yes needed to do it? (range:0 - 100%) */
	sInt	maxmessages;	/* limit of number of CMESSAGES_UL per second
				   per client. 0 is none, -1 is no limit. */
	sInt	maxmesbytes;	/* limit of number of bytes of CMESSAGES_UL per
				   second per client. 0 is none, -1 is no limit.
				   These two fields are independent. */
	sInt	maxobjcreate;	/* limit of creation of objects per client per
				   second */
	sInt	maxobjmodify;	/* limit of modification of objects per client
				   per second */
	sInt	maxobjmove;	/* limit of movimentation of objects per client
				   per second */
	TIME_UL	maxsimtime;	/* Max time of simulation. After this, the
				   server quits. All fields == zero: none.*/
};
typedef struct pref_ul PREF_UL;

/* pref.c */
extern PREF_UL			*prefs;
extern sInt loadprefs 		( void );
extern void saveprefs 		( void );

/* ulserver.c */
extern sInt			nclients, actual;
extern TRACK_UL 		*ptrack;
extern SIMPLECLIENT_UL		*firstclient;
extern void removeconnection	( sInt sock );
/* netio.c */
extern void netsend 		( sInt fd, SERVERM_UL *msg );
extern void netflush 		( void );
extern CLIENTM_UL *netrcv 	( sInt fd );
extern sInt netmore 		( void );

#endif
